seafile-containerized/launcher

319 lines
8.1 KiB
Plaintext
Raw Normal View History

#!/bin/bash
2016-11-21 04:56:33 +00:00
usage () {
echo "Usage: launcher COMMAND [--skip-prereqs] [--docker-args STRING]"
2016-11-21 04:56:33 +00:00
echo "Commands:"
echo " start: Start/initialize a container"
echo " stop: Stop a running container"
echo " restart: Restart a container"
echo " destroy: Stop and remove a container"
echo " enter: Open a shell to run commands inside the container"
echo " logs: View the Docker logs for a container"
echo " bootstrap: Bootstrap a container for the config based on a template"
echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
echo
echo "Options:"
echo " --skip-prereqs Don't check launcher prerequisites"
echo " --docker-args Extra arguments to pass when running docker"
exit 1
}
set -e
set -o pipefail
version=6.0.5
image=seafileorg/server:$version
local_image=local_seafile/server:latest
2016-11-12 07:15:26 +00:00
dockerdir=$(cd "$(dirname $0)"; pwd -P)
sharedir=$dockerdir/shared
installdir=/opt/seafile/seafile-server-$version
2016-11-16 01:46:08 +00:00
bootstrap_conf=$dockerdir/bootstrap/bootstrap.conf
cd $dockerdir
dbg() {
if [[ $debug == "true" ]]; then
echo "dbg: $1"
fi
}
2016-11-25 06:14:30 +00:00
show_progress() {
if [[ -t 1 ]]; then
>&2 printf "[$(date +'%Y-%m-%d %H:%M:%S')] \033[32m%s\033[m\n" "$1"
else
>&2 echo "[$(date +'%Y-%m-%d %H:%M:%S')] " "$1"
fi
}
2016-11-21 04:56:33 +00:00
install_docker() {
2016-11-25 04:04:37 +00:00
echo "---------------------------------------------------------------------------------"
2016-11-21 04:56:33 +00:00
echo "Docker is not installed, you will need to install Docker in order to run Launcher"
echo "See https://docs.docker.com/installation/"
2016-11-25 04:04:37 +00:00
echo "---------------------------------------------------------------------------------"
2016-11-21 04:56:33 +00:00
exit 1
}
err_and_quit () {
2016-11-25 06:14:30 +00:00
if [[ -t 1 ]]; then
>&2 printf "\n\n\033[33mError: %s\033[m\n\n" "$1"
else
>&2 echo "$1"
fi
exit 1
}
init_shared() {
mkdir -p $sharedir/{seafile,db}
mkdir -p $sharedir/logs/{seafile,var-log}
2016-11-12 07:15:26 +00:00
mkdir -p $sharedir/logs/var-log/nginx
touch $sharedir/logs/var-log/syslog
local bash_history=$sharedir/.bash_history
if [[ ! -e $bash_history ]]; then
touch $bash_history
fi
}
set_ports() {
ports=$(docker run $user_args --rm -it \
2016-11-16 01:46:08 +00:00
-v ${dockerdir}/scripts:/scripts \
-v ${dockerdir}/bootstrap:/bootstrap:ro \
$image \
/scripts/bootstrap.py --parse-ports)
}
set_bootstrap_volumes() {
local mounts
init_shared
mounts=(
$sharedir:/shared
2016-11-12 05:27:24 +00:00
$sharedir/logs/var-log:/var/log
$sharedir/db:/var/lib/mysql
$dockerdir/bootstrap:/bootstrap
$dockerdir/scripts:/scripts:ro
$dockerdir/templates:/templates:ro
$dockerdir/scripts/tmp/check_init_admin.py:$installdir/check_init_admin.py:ro
$sharedir/.bash_history:/root/.bash_history
)
volumes=""
local m
for m in ${mounts[*]}; do
volumes="$volumes -v $m"
done
}
set_volumes() {
local mounts
init_shared
mounts=(
$sharedir:/shared
$sharedir/logs/var-log:/var/log
$sharedir/db:/var/lib/mysql
$sharedir/.bash_history:/root/.bash_history
)
volumes=""
local m
for m in ${mounts[*]}; do
volumes="$volumes -v $m"
done
}
2016-11-21 04:56:33 +00:00
set_existing_container() {
existing=$(docker ps -a | awk '{ print $1, $(NF) }' | grep " seafile$" | awk '{ print $1 }' || true)
}
bootstrap() {
2016-11-12 07:15:26 +00:00
if [[ ! -e $bootstrap_conf ]]; then
err_and_quit "The file $bootstrap_conf doesn't exist. Have you run seafile-server-setup?"
fi
2016-11-25 06:18:43 +00:00
docker history $image >/dev/null 2>&1 || {
show_progress "Pulling Seafile server image $version, this may take a while."
docker pull $image
show_progress "Seafile server image $version pulled. Now bootstrapping the server ..."
2016-11-25 06:18:43 +00:00
}
# First initialize seafile server and letsencrypt
set_bootstrap_volumes
set_ports
docker run $user_args --rm -it --name seafile-bootstrap -e SEAFILE_BOOTSRAP=1 $volumes $ports $image /sbin/my_init -- /scripts/bootstrap.py
2016-11-25 06:14:30 +00:00
show_progress "Now building the local docker image."
docker build -f bootstrap/generated/Dockerfile -t local_seafile/server:latest . >/dev/null
show_progress "Image built."
}
start() {
2016-11-21 04:56:33 +00:00
existing=$(docker ps | awk '{ print $1, $(NF) }' | grep " seafile$" | awk '{ print $1 }' || true)
if [[ $existing != "" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Nothing to do, your container has already started!"
2016-11-21 04:56:33 +00:00
exit 0
fi
2016-11-25 08:38:54 +00:00
chmod 0700 $dockerdir/bootstrap $sharedir/seafile/conf
2016-11-21 04:56:33 +00:00
set_existing_container
if [[ $existing != "" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "starting up existing container"
2016-11-21 04:56:33 +00:00
(
set -x
docker start seafile
)
exit 0
fi
set_volumes
set_ports
2016-11-21 04:56:33 +00:00
local restart_policy attach_on_run
if [[ "${SUPERVISED}" = "true" ]]; then
restart_policy="--restart=no"
attach_on_run="-a stdout -a stderr"
else
attach_on_run="-d"
fi
2016-11-25 06:14:30 +00:00
show_progress "Starting up new seafile server container"
2016-11-21 04:56:33 +00:00
(
set -x
2016-11-21 05:34:46 +00:00
docker run $user_args $attach_on_run $restart_policy --name seafile -h seafile $volumes $ports $local_image
2016-11-21 04:56:33 +00:00
)
}
2016-11-25 07:28:20 +00:00
ensure_container_running() {
2016-11-21 04:56:33 +00:00
set_existing_container
2016-11-25 07:28:20 +00:00
if [[ $existing == "" ]]; then
2016-11-25 06:14:30 +00:00
err_and_quit "seafile was not started !"
2016-11-21 04:56:33 +00:00
fi
}
2016-11-25 07:28:20 +00:00
stop() {
ensure_container_running
(
set -x
docker stop -t 10 seafile
)
}
enter() {
2016-11-25 07:28:20 +00:00
ensure_container_running
(
set -x
docker exec -it seafile /bin/bash
)
2016-11-21 04:56:33 +00:00
}
restart() {
stop
start
}
check_prereqs() {
2016-11-21 05:26:41 +00:00
if [[ $SKIP_PREREQS == "true" ]]; then
return 0
fi
# check docker
2016-11-21 04:56:33 +00:00
if ! which docker >/dev/null; then
install_docker
fi
# TODO: check git version
}
logs() {
2016-11-25 07:28:20 +00:00
ensure_container_running
(
set -x
docker logs --tail=20 -f seafile
)
}
destroy() {
(
set -x
docker stop -t 10 seafile || true
docker rm seafile
)
}
rebuild() {
2016-11-25 04:33:10 +00:00
if [[ "$(git symbolic-ref --short HEAD)" == "master" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Ensuring launcher is up to date"
2016-11-25 04:33:10 +00:00
git remote update
LOCAL=$(git rev-parse @)
REMOTE=$(git rev-parse "@{u}")
BASE=$(git merge-base @ "@{u}")
if [[ $LOCAL = "$REMOTE" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Launcher is up-to-date"
2016-11-25 04:33:10 +00:00
elif [[ $LOCAL = "$BASE" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Updating Launcher"
2016-11-25 04:33:10 +00:00
git pull || (echo 'failed to update' && exit 1)
for (( i=${#BASH_ARGV[@]}-1,j=0; i>=0,j<${#BASH_ARGV[@]}; i--,j++ ))
do
args[$j]=${BASH_ARGV[$i]}
done
exec /bin/bash $0 "${args[@]}" # $@ is empty, because of shift at the beginning. Use BASH_ARGV instead.
elif [[ $REMOTE = "$BASE" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Your version of Launcher is ahead of origin"
2016-11-25 04:33:10 +00:00
else
2016-11-25 06:14:30 +00:00
show_progress "Launcher has diverged source, this is only expected in Dev mode"
2016-11-25 04:33:10 +00:00
fi
fi
set_existing_container
if [[ $existing != "" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Stopping old container"
2016-11-25 04:33:10 +00:00
(
set -x
docker stop -t 10 seafile
)
fi
bootstrap
2016-11-25 06:14:30 +00:00
show_progress "Rebuilt successfullly."
2016-11-25 04:33:10 +00:00
if [[ $existing != "" ]]; then
2016-11-25 06:14:30 +00:00
show_progress "Removing old container"
2016-11-25 04:33:10 +00:00
(
set -x
docker rm seafile
)
fi
start
2016-11-25 06:14:30 +00:00
show_progress "Your seafile server is now running."
2016-11-25 04:33:10 +00:00
exit 0
}
main() {
local action
while [[ $# -gt 0 ]]
do
case "$1" in
2016-11-21 05:34:46 +00:00
bootstrap|start|stop|restart|enter|destroy|logs|rebuild)
2016-11-21 04:56:33 +00:00
action=$1 ; shift 1 ;;
--debug) debug=true ; shift 1 ;;
2016-11-21 05:26:41 +00:00
--skip-prereqs) SKIP_PREREQS=true ; shift 1 ;;
--docker-args) user_args=$2 ; shift 2 ;;
*) err_and_quit "Argument error. Please see help." ;;
esac
done
"$action"
}
2016-11-21 04:56:33 +00:00
check_prereqs
main "$@"